@using Microsoft.Extensions.Configuration
@using Microsoft.Extensions.Options
@using Microsoft.JSInterop
@inherits JonesComponentBase

<iframe @attributes="@AdditionalAttributes" id="mapPage" width="100%" height="100%" style="border: 0;" src="@Src">
</iframe>

@inject IOptions<TencentMapConfig> TencentMapConfig
@inject IJSRuntime JsRuntime
@code
{
    [Parameter]
    public double? Longitude { get; set; }
    
    [Parameter]
    public double? Latitude { get; set; }
    
    [Parameter]
    public Action<LocationPickerResult>? OnChange { get; set; }

    protected string Src
    {
        get
        {
            var src = $"https://apis.map.qq.com/tools/locpicker?type=1&key={TencentMapConfig.Value.Key}&referer={TencentMapConfig.Value.Referer}";
            if (Longitude > 0 && Latitude > 0)
            {
                src += $"&coord={Latitude},{Longitude}";
            }
            return TencentMapConfig.Value.SecretKey == null ? src : Signature.TrySignaturedGet(TencentMapConfig.Value.SecretKey, src);
        }
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);

        if (firstRender)
        {
            _ = Init();
        }
    }

    private async Task Init()
    {
        await JsRuntime.InvokeVoidAsync("tencentMap.locationPicker.init", 
            DotNetObjectReference.Create(this), nameof(OnChangeCallback));
    }
    
    [JSInvokable]
    public Task OnChangeCallback(LocationPickerResult value)
    {
        OnChange?.Invoke(value);
        return Task.CompletedTask;
    }
}